// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wLockProcessorView:
//   The Lock processor view.


// -------------------------------------
// Includes
//
#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wLockProcessorView.h"

#include "p4wCmdPane.h"

//
// -------------------------------------
// Constructors and destructor.
//
p4wLockProcessorView::p4wLockProcessorView(p4wRequest & Request)
	: p4wRunView(Request)
{
	ProcessFormAction();		
	fAc = AC_LOCKFRM;
	
	//
	// Set the short and the long versions of the title.
	// If there is no POST data the title is "Error".
	
	if( !ProcessForm() ) {
		fShortTitle.Set( "Error" );
		fFullTitle.Set( "Error" );
		return;
	}
		
	fShortTitle.Set( "Command Result" );
	fFullTitle.Set( "Lock Result" );
}

p4wLockProcessorView::~p4wLockProcessorView()
{
}

// -------------------------------------
// Control item render functions.
//

void p4wLockProcessorView::RenderContent()
{
	//
	// Issue lock command (passing the results through a 
	// CmdPane).

	// Build a spec to parse the lock options

	if( !ProcessForm() ) {
		RenderError("Requested URL is invalid in this context.");
		return;
	}

	//
	// Parse options and build up the command args

	title.Set("Lock ");

	//
	// Process the files. If this returned an error don't issue command

	if( !AddFileArgs() ) 
		return;

	// Run lock
	
	p4wCmdPane cmdPane(*this, fRequest, title.Text());
	fRequest.p4("lock", 0, 0, &cmdPane);
	fRequest.p4Wait();
}

